--- Fl_GIF_Image.old	2015-06-14 19:07:31.000000000 +0200
+++ Fl_GIF_Image.cxx	2018-08-31 15:03:39.068465017 +0200
@@ -112,8 +112,13 @@
 
   uchar ch = NEXTBYTE;
   char HasColormap = ((ch & 0x80) != 0);
-  int BitsPerPixel = (ch & 7) + 1;
-  int ColorMapSize = 1 << BitsPerPixel;
+  int BitsPerPixel = ((ch & 0x70) >> 4) + 1;
+  int ColorMapSize;
+  if (HasColormap) {
+    ColorMapSize = 2 << (ch&7);
+  } else {
+    ColorMapSize = 0;
+  }
   // int OriginalResolution = ((ch>>4)&7)+1;
   // int SortedTable = (ch&8)!=0;
   ch = NEXTBYTE; // Background Color index
@@ -129,10 +134,6 @@
       Green[i] = NEXTBYTE;
       Blue[i] = NEXTBYTE;
     }
-  } else {
-    Fl::warning("%s does not have a colormap.", infname);
-    for (int i = 0; i < ColorMapSize; i++)
-      Red[i] = Green[i] = Blue[i] = (uchar)(255 * i / (ColorMapSize-1));
   }
 
   int CodeSize;		/* Code size, init from GIF header, increases... */
@@ -180,13 +181,20 @@
       ch = NEXTBYTE;
       Interlace = ((ch & 0x40) != 0);
       if (ch&0x80) { 
-	// read local color map
-	int n = 2<<(ch&7);
-	for (i=0; i < n; i++) {	
-	  Red[i] = NEXTBYTE;
-	  Green[i] = NEXTBYTE;
-	  Blue[i] = NEXTBYTE;
-	}
+        // read local color map
+        ColorMapSize = 2<<(ch&7);
+        for (i=0; i < ColorMapSize; i++) {	
+          Red[i] = NEXTBYTE;
+          Green[i] = NEXTBYTE;
+          Blue[i] = NEXTBYTE;
+        }
+      } else {
+        if (ColorMapSize==0) {
+          fclose(GifFile);
+          Fl::error("%s does not have a colormap.\n", infname);
+          ld(ERR_FORMAT);
+          return;
+        }
       }
       CodeSize = NEXTBYTE+1;
       break; // okay, this is the image we want
